//  t@CǂݍݗpXg[
//
//    2002/10/ 9 ˁ@P

#include "windef.h"
#include "define.h"
#include "interfaces.h"
#include "classes.h"
#include <stdexcept>

using namespace std;

D2CFileReaderStream::D2CFileReaderStream(const CSTR csArg) {

	m_fp=fopen(csArg,"rb");

}

D2CFileReaderStream::~D2CFileReaderStream() {

	if (m_fp!=NULL)
		fclose(m_fp);

}

UI32 D2CFileReaderStream::getClassID() const { return CID_D2CFileReaderStream; }

UI32 D2CFileReaderStream::getObjectType() const {

	I32 i32ID=VER_D2_0 << 24;
	i32ID+=TYPE_BUF << 16;
	i32ID+=ENCODE_NONE;

	return i32ID;

}

UI8 D2CFileReaderStream::getObjectVersion() const { return VER_D2_0; }
UI8 D2CFileReaderStream::getDataType() const { return TYPE_BUF; }
UI16 D2CFileReaderStream::getEncoding() const { return ENCODE_NONE; }

void * D2CFileReaderStream::getInterface(UI32 u32Arg) {

	switch(u32Arg) {

	case IID_D2IObject:
		return (D2IObject *)this;

	case IID_D2IStreamReader:
		return (D2IStreamWriter *)this;

	}

	return NULL;

}

CSTR D2CFileReaderStream::getCSTR() { return NULL; }

bool D2CFileReaderStream::seek(I32 i32Arg) {

	if (m_fp==NULL || i32Arg<0)
		return false;

	return (fseek(m_fp,i32Arg,SEEK_SET)==0);

}

bool D2CFileReaderStream::close() {

	if (m_fp==NULL)
		return true;

	fclose(m_fp);
	m_fp=NULL;

	return true;

}

UI8 D2CFileReaderStream::read() {

	if (m_fp==NULL)
		return false;

	UI8 u8Tmp;

	if (feof(m_fp))
		throw range_error("ȃXg[|C^");

	if (fread(&u8Tmp,1,1,m_fp)<1)
		throw runtime_error("ǂݎG[");

	return u8Tmp;

}

I32 D2CFileReaderStream::read(BUF bfArg,I32 i32Arg) {

	if (m_fp==NULL)
		return 0;

	return fread(bfArg,1,i32Arg,m_fp);

}

I32 D2CFileReaderStream::read(D2IBufferWriter *pbwArg) {

	if (pbwArg==NULL || pbwArg->getSize()<1)
		return 0;

	I32 i32Length=pbwArg->getSize();
	
	BUF bfTmp=(BUF)D2Malloc(i32Length);

	if (bfTmp==NULL)
		return 0;

	I32 i32Read=read(bfTmp,i32Length);

	I32 i32Done=pbwArg->write(0,bfTmp,i32Read);

	D2Free(bfTmp);

	return i32Done;

}
