#include "windef.h"
#include "define.h"
#include "interfaces.h"
#include "classes.h"

D2CFileWriterStream::D2CFileWriterStream(CSTR csArg) {

	m_fp=fopen(csArg,"wb");

}

D2CFileWriterStream::~D2CFileWriterStream() {

	if (m_fp!=NULL)
		fclose(m_fp);

}

UI32 D2CFileWriterStream::getClassID() const { return CID_D2CFileWriterStream; }

UI32 D2CFileWriterStream::getObjectType() const {

	I32 i32ID=VER_D2_0 << 24;
	i32ID+=TYPE_STREAM << 16;
	i32ID+=ENCODE_NONE;

	return i32ID;

}

UI8 D2CFileWriterStream::getObjectVersion() const { return VER_D2_0; }
UI8 D2CFileWriterStream::getDataType() const { return TYPE_BUF; }
UI16 D2CFileWriterStream::getEncoding() const { return ENCODE_NONE; }

void * D2CFileWriterStream::getInterface(UI32 u32Arg) {

	switch(u32Arg) {

	case IID_D2IObject:
		return (D2IObject *)this;

	case IID_D2IStreamWriter:
		return (D2IStreamWriter *)this;

	}

	return NULL;

}

CSTR D2CFileWriterStream::getCSTR() { return NULL; }

bool D2CFileWriterStream::seek(I32 i32Arg) {

	if (m_fp==NULL || i32Arg<0)
		return false;

	return (fseek(m_fp,i32Arg,SEEK_SET)==0);

}

bool D2CFileWriterStream::close() {

	if (m_fp==NULL)
		return true;

	fclose(m_fp);
	m_fp=NULL;

	return true;

}

bool D2CFileWriterStream::write(UI8 u8Arg) {

	if (m_fp==NULL)
		return false;

	fwrite(&u8Arg,1,1,m_fp);

	return true;

}

I32 D2CFileWriterStream::write(const BUF bfArg,I32 i32Arg) {

	if (m_fp==NULL)
		return 0;

	return fwrite(bfArg,1,i32Arg,m_fp);

}

I32 D2CFileWriterStream::write(const D2IBufferReader *pbrArg) {

	if (m_fp==NULL || pbrArg==NULL || pbrArg->getSize()<1)
		return 0;

	BUF bfTmp=pbrArg->copy();

	if (pbrArg==NULL)
		return 0;

	return fwrite(bfTmp,1,pbrArg->getSize(),m_fp);

}
